/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
-------------------------------------------------------------------------------------
 Programma poiska resheniya sistem lineynih algebraicheskih uravneniy metodom otrajeniy (Lineyniy massiv).

   Po-umolchaniu programma poluchaet dannie iz "input.txt": reazmer matritsi; soderjanie 
matrici. Resultat vivodit v "output.txt". Kluchem -l programma nachnet rabotat' v rejime 
polnogo razbora(s klaviaturi poluchaet imena vhodnogo i vihodnogo fila, po okonchanii raboti 
vivodit ih na ekran). Cherez komandnuu stroku ona mojet poluchat' imena vhodnogo i vihodnogo fila.
-------------------------------------------------------------------------------------

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define STR_FILE_IN_NAME "input.txt"
#define STR_FILE_OUT_NAME "output.txt"
int MkOutFile(FILE *f_in, FILE *f_out);
bool bAll=false;

int main(int argc, char* argv[])
{
	char sFInName[256]=STR_FILE_IN_NAME, sFOutName[256]=STR_FILE_OUT_NAME, *pNothingDo;
	FILE *f_in, *f_out;
	char cRead;
	if(argc>1){
		if((argv[1][0]=='-')&&(argv[1][1]=='l')&&(argv[1][2]=='\0')){
			bAll=true;
		} else {
			pNothingDo=strcpy(sFInName,argv[1]);
			if(argc>2) pNothingDo=strcpy(sFOutName,argv[2]);
		}
	}
	//----------------begin all---
	if(bAll){
		printf("Input name of Input File:");
		scanf("%s",sFInName);
		printf("Input name of Output File:");
		scanf("%s",sFOutName);
	}
	//----------------end all-----
	f_in=fopen(sFInName,"r");
	f_out=fopen(sFOutName,"w");
	if (!f_in){
		printf("Error: can't open file with name %s\n", sFInName);
		if(bAll) scanf("%c", &cRead);
		return -1;
	}
	if (!f_out){
		printf("Error: can't open file with name %s\n", sFOutName);
		if(bAll) scanf("%c", &cRead);
		return -1;
	}
	if(MkOutFile(f_in, f_out)>=0){
		printf("Program was finished successfully!\n");
	} else {
		printf("Program was finished unsuccessfully!\n");
	}
	fclose(f_in);
	fclose(f_out);
	//----------------begin all---
	if(bAll){
		double dRead;
		f_in=fopen(sFInName,"r");
		f_out=fopen(sFOutName,"r");
		printf("Input File:\n");
		while(fscanf(f_in, "%lg", &dRead)==1){
			printf("%lg ",dRead);
		}
		printf("\n");
		printf("Output File:\n");
		while(fscanf(f_out, "%lg", &dRead)==1){
			printf("%lg ",dRead);
		}
		printf("\n");
		fclose(f_in);
		fclose(f_out);
	}
	if(bAll) scanf("%c", &cRead);
	//----------------end all-----
	return 0;
}

int MkOutFile(FILE *f_in, FILE *f_out)
{
	long int N;
	long int i=0, j=0, k=0, l=0;
	bool bZ;
	double alpha, ro;
	double *A, *U, *A1, *b, *w, *b1, *x;
	if(fscanf(f_in, "%ld", &N)!=1) return -1;
	if(N<=0) return -1;
	A = new double[N*N];
	b = new double[N];
	w = new double[N];
	U = new double[N*N];
	A1 = new double[N*N];
	b1 = new double[N];
	i=0;
	j=0;
	while (i<N) {
		j=0;
		while (j<N){
			if(fscanf(f_in, "%lg", &A[i*N+j])!=1) return -1;
			j++;
		}
		if(fscanf(f_in, "%lg", &b[i])!=1) return -1;
		i++;
	}
	i=0;
	j=0;
	while (j<N) {
		bZ=true;
		i=j+1;
		while (i<N){
			if (A[i*N+j]!=0) bZ=false;
			i++;
		}
		if (bZ) {
			j++;
		} else {
			// schitaem alpha
			alpha=0;
			i=j;
			while (i<N) {
				alpha=alpha+A[i*N+j]*A[i*N+j];
				i++;
			}
			alpha=sqrt(alpha);
			//schitaem ro
			i=j;
			ro=(A[i*N+j]+alpha)*(A[i*N+j]+alpha);
			i=j+1;
			while (i<N) {
				ro=ro+A[i*N+j]*A[i*N+j];
				i++;
			}
			ro=sqrt(ro);
			//schitaem w
			w[0]=(A[j*N+j]+alpha)/ro;
			i=1;
			while (i<N-j) {
				w[i]=A[(i+j)*N+j]/ro;
				i++;
			}
			//schitaem U
			k=0;
			while (k<N-j) {
				l=0;
				while (l<N-j) {
					if (k==l) {
						U[l*(N-j)+k]=1-2*w[k]*w[l] ;
					} else {
						U[l*(N-j)+k]=-2*w[k]*w[l];
					}
					l++;
				}
				k++;
			}
			//schitaem A'
			i=j;
			while (i<N) {
				k=j;
				while (k<N) {
					A1[(i-j)*(N-j)+(k-j)]=A[i*N+k];
					k++;
				}
				i++;
			}
			i=j;
			A[i*N+j]=-alpha;
			i=j+1;
			while (i<N) {
				A[i*N+j]=0;
				i++;
			}
			i=j;
			while (i<N) {
				k=j+1;
				while (k<N) {
					l=0;
					A[i*N+k]=0;
					while (l<N-j) {
						A[i*N+k]=A[i*N+k]+U[(i-j)*(N-j)+l]*A1[l*(N-j)+(k-j)];					
						l++;
					}
					k++;
				}
				i++;
			}
			//schitaem b'
			i=j;
			while (i<N) {
				b1[i-j]=b[i];
				i++;
			}
			i=j;
			while (i<N) {
				l=0;
				b[i]=0;
				while (l<N-j) {
					b[i]=b[i]+U[(i-j)*(N-j)+l]*b1[l];
					l++;
				}
				i++;
			}
			j++;
		}
	}
	bZ=false;
	i=0;
	while (i<N) {
		if (A[i*N+i]==0) bZ=true;
		i++;
	}
	if (bZ) {
		fprintf(f_out,"Sistema virojdena!!!\n");
	} else {
		x=new double[N];
		i=N-1;
		while (i>-1) {
			j=i+1;
			x[i]=b[i];
			while (j<N) {
				x[i]=x[i]-A[i*N+j]*x[j];
				j++;
			}
			x[i]=x[i]/A[i*N+i];
			i--;
		}
		i=0;
		while (i<N) {
			fprintf(f_out,"%lg\n", x[i]);
			i++;
		}
		delete [] x;
	}
	delete [] w;
	delete [] U;
	delete [] A1;
	delete [] b1;
	delete [] A;
	delete [] b;
	return 1;
}
/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/
